unit uFrmBase;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, Vcl.StdCtrls;

type
  TFrmBase = class(TForm)
    memMsg: TMemo;
  private
    { Private declarations }
  protected
    procedure DispMsg(AMsg: string);
    procedure OnDispMsg(AMsg: string);
    procedure OnThreadDispMsg(AMsg: string);
  public
    { Public declarations }
  end;


implementation

{$R *.dfm}
{ TFrmBase }

procedure TFrmBase.DispMsg(AMsg: string);
begin
  if memMsg.Lines.Count > 5000 then
    memMsg.Clear;
  memMsg.Lines.Add(AMsg);
end;

procedure TFrmBase.OnDispMsg(AMsg: string);
begin
  DispMsg(AMsg);
end;

procedure TFrmBase.OnThreadDispMsg(AMsg: string);
begin

  TThread.Queue(nil,
    procedure
    begin
      DispMsg(AMsg);
    end);

end;

end.
